<template>
  <div
    v-show="message !== 'O evento começou'"
    class="background-height background-gradient-reverse text-white"
  >
    <div class="flex items-center svg-maneirissimo">
      <div class="container mx-auto flex flex-row items-center text-center md:text-left h-full">
        <div class="inline-flex flex-col justify-center items-center w-full h-full">
          <img src="~/assets/logo.svg" class="logo mx-4" alt="Logo do DeepHack" />
          <div class="flex-grow"></div>
          <a
            id="scroll"
            v-smooth-scroll="{ duration: 750, offset: 0 }"
            href="#subscribe"
            aria-label="Scroll para o início da página"
          >
            <span id="scroll-icon">
              <i class="fas fa-chevron-down"></i>
            </span>
          </a>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  data: function() {
    return {
      start: "",
      end: "",
      interval: "",
      days: "77",
      minutes: "6",
      hours: "4",
      seconds: "10",
      message: "",
      innerPercentage: 0.1,
      outterPercentage: 0.1,
      isEaster: false,
      petals: []
    };
  },
  mounted() {
    const interhackDate = new Date("11/09/2019 10:00:00");
    const petalsAmmount = 24;
    for (let i = 0; i < petalsAmmount; i++)
      this.petals.push((i * 360) / petalsAmmount);
    setInterval(() => {
      const diffMilisseconds = interhackDate.getTime() - Date.now();
      const timeRemaining = this.parseMilisseconds(diffMilisseconds);
      this.days = timeRemaining.days;
      this.hours = timeRemaining.hours;
      this.minutes = timeRemaining.minutes;
      this.seconds = timeRemaining.seconds;
      this.outterPercentage = diffMilisseconds / 8701658403;
      this.innerPercentage = (diffMilisseconds % 8.64e7) / 8.64e7;
    });
  },
  methods: {
    parseMilisseconds(ms) {
      const days = Math.floor(ms / 8.64e7);
      const hours = Math.floor((ms % 8.64e7) / 3.6e6);
      const minutes = Math.floor(((ms % 8.64e7) % 3.6e6) / 60000);
      const seconds = Math.floor((((ms % 8.64e7) % 3.6e6) % 60000) / 1000);
      return { days, hours, minutes, seconds };
    },

    async easterEgg() {
      if (this.isEaster) return;
      const sleep = time => new Promise(resolve => setTimeout(resolve, time));
      this.isEaster = true;
      await sleep(3000);
      this.isEaster = false;
    }
  }
};
</script>

<style scoped>
svg {
  width: 300px;
  height: 300px;
  position: relative;
}

@keyframes easter-egg {
  from {
    transform: rotate(0deg);
  }
  to {
    transform: rotate(360deg);
  }
}

@keyframes easter-egg-reverse {
  from {
    transform: rotate(360deg);
  }
  to {
    transform: rotate(0deg);
  }
}

.easter {
  transform-origin: 0.5px 0.5px;
  animation-name: easter-egg;
  animation-duration: 3s;
  animation-timing-function: ease;
  animation-direction: normal;
}

.easter-reverse {
  transform-origin: 0.5px 0.5px;
  animation-name: easter-egg-reverse;
  animation-duration: 3s;
  animation-timing-function: ease;
  animation-direction: normal;
}

.svg-container {
  width: 300px;
  height: 300px;
  display: grid;
  grid-template-rows: 0 100%;
  text-align: center;
}

.svg-container p {
  font-family: "Trebuchet MS", "Lucida Sans Unicode", "Lucida Grande",
    "Lucida Sans", Arial, sans-serif;
  width: max-content;
  height: max-content;
  justify-self: center;
  align-self: center;
  user-select: none;
}

.background-height {
  height: calc(var(--vh, 1vh) * 100);
  position: relative;
}

.svg-maneirissimo {
  height: calc(var(--vh, 1vh) * 100);
}

.text-large {
  font-size: 32px;
}

#scroll {
  background-color: white;
  border-radius: 100%;
  height: 50px;
  width: 50px;
  box-shadow: 0px 2px 5px rgba(0, 0, 0, 0.25);
  display: flex;
  align-items: center;
  justify-content: center;
}

#scroll:hover {
  animation-name: animationHover;
  animation-duration: 2s;
  animation-iteration-count: 1;
  animation-fill-mode: backwards;
}

@keyframes animationHover {
  0% {
    transform: translateY(0);
  }
  20% {
    transform: translateY(10px);
  }
  40% {
    transform: translateY(0);
  }
}

#scroll-icon {
  color: theme("colors.secondary");
  font-size: 24px;
  height: 24px;
}

@media (min-width: 992px) {
  .text-large {
    font-size: 48px;
  }
}
</style>
